VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Object = "{68523E40-56EB-11D3-B739-CAA1986A452F}#1.0#0"; "LGRID.OCX"
Begin VB.Form frmMain 
   Caption         =   "MDB table viewer (LiteGrid control test)"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog cd 
      Left            =   1320
      Top             =   600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327681
      DialogTitle     =   "Opan an Access database"
      Filter          =   "Access database (*.mdb)|*.mdb"
   End
   Begin LGRIDLibCtl.LiteGrid lg 
      Height          =   1335
      Left            =   360
      OleObjectBlob   =   "frmMain.frx":0000
      TabIndex        =   5
      ToolTipText     =   "Table data"
      Top             =   1680
      Width           =   3975
   End
   Begin VB.CommandButton cmdFind 
      Caption         =   "Find"
      Height          =   375
      Left            =   3360
      TabIndex        =   4
      ToolTipText     =   "Press to find next matching pattern in currently selected column of the LiteGrid"
      Top             =   1080
      Width           =   1095
   End
   Begin VB.TextBox txtFindPattern 
      Height          =   375
      Left            =   240
      TabIndex        =   3
      ToolTipText     =   "Type text pattern (uses Like operator synthax) to find in the selected column of the grid"
      Top             =   1080
      Width           =   2895
   End
   Begin VB.CommandButton cmdAbout 
      Caption         =   "About..."
      Height          =   375
      Left            =   3240
      TabIndex        =   2
      ToolTipText     =   "About program"
      Top             =   240
      Width           =   1335
   End
   Begin VB.ComboBox cbTables 
      Height          =   315
      Left            =   1560
      Style           =   2  'Dropdown List
      TabIndex        =   1
      ToolTipText     =   "Select a table to see from the list"
      Top             =   240
      Width           =   1575
   End
   Begin VB.CommandButton cmdOpenDatabase 
      Caption         =   "&Open..."
      Height          =   375
      Left            =   120
      TabIndex        =   0
      ToolTipText     =   "Press to locate an existing MSJet database"
      Top             =   120
      Width           =   1215
   End
   Begin VB.Line lin 
      BorderColor     =   &H80000005&
      Index           =   1
      X1              =   120
      X2              =   4320
      Y1              =   960
      Y2              =   960
   End
   Begin VB.Line lin 
      BorderColor     =   &H80000010&
      Index           =   0
      X1              =   120
      X2              =   4320
      Y1              =   840
      Y2              =   840
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

Dim mdbs As DAO.Database
' loads a table from mdbs database into lg
' Arguments:
'   TableName = in, Name of a database table
Private Sub ShowTable(TableName As String)
Dim i, j As Integer
Dim f As DAO.Field
On Error GoTo ErrHandler
Dim rst As DAO.Recordset
    ' clear grid
    lg.Rows = 2
    lg.Cols = 1
    lg.CellText(0, 0) = ""
    lg.CellText(1, 0) = ""
    ' try to open the given table
    Set rst = mdbs.OpenRecordset(TableName)
    If rst.BOF Then
        MsgBox "The selected table is empty"
        Exit Sub
    End If
    ' BeginWaitCursor
    Me.MousePointer = vbHourglass
    ' insert field names into the grid
    i = 0
    For Each f In rst.Fields
        ' add all fields except MEMO-like
        If f.Type <> dbBinary And f.Type <> dbLongBinary _
          And f.Type <> dbMemo And f.Type <> dbVarBinary Then
            If lg.Cols <= i Then lg.Cols = i + 1
            lg.CellText(0, i) = f.Name
            lg.ColWidth(i) = lg.GetNormalTextWidth(String(IIf(f.Size < 4, 5, IIf(f.Size > 50, 50, f.Size)), "a"))
            If lg.ColWidth(i) < lg.GetFixedTextWidth(f.Name) Then lg.ColWidth(i) = lg.GetFixedTextWidth(f.Name)
            i = i + 1
        End If
    Next
    ' insert all data from the recordset to the grid
    rst.MoveFirst
    i = 1
    While Not rst.EOF
    ' add 10 rows at once - to speed up
        If lg.Rows <= i Then lg.Rows = i + 10
        j = 0
        For Each f In rst.Fields
            If f.Type <> dbBinary And f.Type <> dbLongBinary _
              And f.Type <> dbMemo And f.Type <> dbVarBinary Then _
              lg.CellText(i, j) = IIf(IsNull(f.Value), "", f.Value): j = j + 1
        Next
        i = i + 1
        rst.MoveNext
    Wend
    ' adjust number of rows in the grid
    With lg
        .Rows = i
        .Row = 1
        .Col = 0
    End With
    ' EndWaitCursor
    Me.MousePointer = vbNormal
    Exit Sub
ErrHandler:
    Me.MousePointer = vbNormal
    MsgBox Err.Source & ":" & Err.Description, vbCritical, "Error occured"
End Sub
Private Sub cbTables_Click()
    ShowTable cbTables.Text
    lg.SetFocus
End Sub

Private Sub cmdAbout_Click()
    frmAbout.Show vbModal
End Sub

Private Sub cmdFind_Click()
Dim i As Integer
    i = lg.Row + 1
    If i >= lg.Rows Then
        i = 1
    End If
    Do While i < lg.Rows
        If lg.CellText(i, lg.Col) Like txtFindPattern Then
            lg.Row = i
            Exit Sub
        End If
        i = i + 1
    Loop
End Sub

Private Sub cmdOpenDatabase_Click()
Dim tdf As DAO.TableDef
On Error GoTo ErrHandler
    cd.ShowOpen
    If cd.filename = vbNullString Then Exit Sub
    ' try to open the selected database
    Set mdbs = OpenDatabase(cd.filename)
    ' fill combo with database's tables
    cbTables.Clear
    For Each tdf In mdbs.TableDefs
        cbTables.AddItem tdf.Name
    Next
    ' clear the grid
    lg.Rows = 2
    lg.Cols = 1
    Exit Sub
ErrHandler:
    MsgBox Err.Source & ":" & Err.Description, vbCritical, "Error occured"
End Sub

Private Sub Form_Resize()
Const GapSize = 100
    If Me.Width < 4000 Then
        Me.Width = 4000
        Exit Sub
    End If
    If Me.Height < 3000 Then
        Me.Height = 3000
        Exit Sub
    End If
' just layout controls - to have a nice look
    With cmdOpenDatabase
        .Top = GapSize
        .Left = GapSize
    End With
    With cmdAbout
        .Top = GapSize
        .Left = ScaleWidth - .Width - GapSize
    End With
    With cbTables
        .Top = GapSize
        .Left = cmdOpenDatabase.Width + GapSize * 2
        .Width = cmdAbout.Left - .Left - GapSize
    End With
    Dim l As Line
    For Each l In lin
        l.X1 = 0
        l.X2 = ScaleWidth
        l.Y1 = cmdOpenDatabase.Height + GapSize * 2
        l.Y2 = l.Y1
    Next
    lin(1).Y1 = lin(1).Y1 + 10
    lin(1).Y2 = lin(1).Y1
    With cmdFind
        .Top = lin(0).Y1 + GapSize
        .Left = ScaleWidth - .Width - GapSize
    End With
    With txtFindPattern
        .Top = cmdFind.Top
        .Left = GapSize
        .Width = cmdFind.Left - GapSize * 2
    End With
    With lg
        .Left = 0
        .Top = txtFindPattern.Top + txtFindPattern.Height + GapSize
        .Width = ScaleWidth
        .Height = ScaleHeight - .Top
    End With
End Sub

